<?
require_once("functions.phps");
$ccount=number_format(@mysql_result(dosql("select count(1) from codepoint"), 0, 0));
?>
<html>
<head>
<title>The Unisearcher Info Guide</title>
<? require('meta.phps'); ?>
<link rel="stylesheet" href="style.css" type="text/css">
<script language="Javascript" src="inc.js"></script>
</head>

<body bgcolor="#eeddff" link="#0000ee" vlink="#0000ee" alink="#ff0000">
<h3>Unisearch's Informative Information Guide</h3>
<table border="0" cellpadding="0" cellspacing="0" width="95%">


<tr><th valign="middle" align="left" colspan="2" class="spanrow">
Capabilities
</th></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Codepoint Range
</th><td valign="top" class="help">
The Unisearcher has every Unicode codepoint between <B>0x00</B> and <B>0xFFFFF</B>. That's over one
million different <I>possible</I> characters (that's what a "codepoint" is: a single character),
but at present there are really only <?=$ccount?> actual characters in the official database.
If you're wondering, a "codepoint" means a character or a glyph, everything from A to &#12378; ("zu" in
Japanese; see, you're learning already). Codepoints are the numerical representation of a character's
position in the Unicode database, usually given in hexadecimal like "0x305A" for our friend &#12378;
or "0x41" for "A", but sometimes (like HTML entities) in decimal; &#12378; is 12378 in decimal, 305A
in hex. Maybe I should've put a glossary at the start of this help file...
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Character Info
</th><td valign="top" class="help">
Information is available for the following characteristics of each codepoint, where available:<BR>
<UL>
<LI><B>Codepoint:</B> This is a hexadecimal number unique to a certain character, sort of its "serial number."</LI>
<LI><B>Description:</B> Not every character has an English description (not to be confused with a definition), but most do.</LI>
<LI><B>Shift-JIS:</B> A character's Shift-JIS hex code, if it has one, to use when encoding characters in that charset.</LI>
<LI><B>Definitions:</B> The English definition(s) for a Kanji character, or "CJK" (Chinese, Japanese, and Korean).</LI>
<LI><B>Code Block:</B> The Unicode "code blocks," logical groups of related characters, are shown for all characters. </LI>
<LI><B>UTF-8 Hex Code:</B> This is calculated dynamically from the hex Codepoint itself and is shown for all characters.<BR>
If you're interested, here's the algorithm to convert a character number to UTF8:
<pre>if(while(!X_X!) & 2){z{0.O}(@-&lt;--)not}do{!#$1-99/xx/ff}i, x{y}[2](j)!1:3</pre>
...where "z" is the number. And yes, that was a joke. It's far too complicated to show here. Made ya look...
</LI>
<LI><B>Pronunciations:</B> How to pronounce a character is available for the following languages:
<UL>
<LI>Japanese "Kun" in Romaji form</LI>
<LI>Japanese "On" in Romaji form</LI>
<LI>Hanyu Pinyin, an English approximation of Chinese syllables</LI>
<LI>Cantonese, which somehow differs from the other Chinese above</LI>
<LI>Vietnamese</LI>
<LI>Korean</LI>
</UL>
</LI>
<a name="comb">
<LI><B>Combining Forms:</B>
A "combining form" is a character that modifies <I>another</I> character.
For example, the "character" &#3607;&#3637;&#3656; is actually <I>three</I>
different characters all smashed together in the same place. I can't show a
combining form by itself, really, but you can see how it works in this
progression:
<blockquote>
&#3607; &#3607;&#3637; &#3607;&#3656; &#3607;&#3637;&#3656;<BR>
</blockquote>
That's Thai, by the way. <a target="_blank" href="index.php?dosearch=y&utf8hex=E0B897E0B8B5E0B988">This</a> and
<a href="javascript: PopMulti('3607:3637:3656')">this</a> will show you
the different pieces. Those three characters are each stored by themselves in the database. If you
enter a UTF-8-compatible string containing combined characters like that one into the "UTF8 String"
form field, it will return each actual character in it separately. This shouldn't hinder you finding them or
converting UTF-8 strings or even long hex-code conglomerations into their correct combined form.
<BR><BR>
Note how the middle character, enigmatically called "Sara Ii", doesn't show up as a combining
form character even though it is. That's because the Unicode database is imperfect. It's hard
enough as it is finding all of them, and I was bound to miss some despite using about three
different finding algorithms to identify them. So that explains that. It's not my fault. Really.
<BR>
Another fun example. You can make a big tilde with two combiners by themselves, like this:
<font size="5"> &#65058;&#65059; </font>
Isn't that ugly? I don't know why they did that. Anyway, combiners don't <I>always</I> require
another character to latch onto to become visible, but if there's a <I>compatible</I> one available,
it will. I say "compatible" because combiners are picky about what they combine with. You can't mix
our Sara Ii with a Latin "A" because they're from different alphabets, or something. I don't know the
full logic behind doing that, or the full rules per RFC or whatever. I just went through every block
with combiners in it, picked out the simplest character that they could all combine with, and defined
a lookup table that returns what character to combine a combiner with. It's technical. Let's just say
it was a lot of work fully supporting combiners in Unisearch, and it's still not perfect because the
data I have to work with isn't perfect. If someone knows of a better data file to get combiners from
than their "UnicodeData.txt" file, let me know.
<BR><BR>
Anywhere you see a character displayed <font color="#CC0000">in red</font>, it means you're actually
viewing a combining-form character combined <I>with</I> some other character that it's compatible with.
If I didn't do this, some combining characters would simply be invisible.
</LI>
</UL>
</td></tr>


<tr><th nowrap valign="top" align="left" class="help_hdr">
Statistics
</th><td valign="top" class="help">
The official counts of everything, from the last 'parser' run:<BR>
<UL>
<LI><B>67,446</B> Total Characters</LI>
<LI><B>31,915</B> Character descriptions</LI>
<LI><B>11,399</B> ShiftJIS-to-Unicode mappings</LI>
<LI><B>20,925</B> English definitions</LI>
<LI><B>65,675</B> Various pronunciations</LI>
<LI><B>196</B> Character grouping blocks</LI>
<LI><B>978</B> Combining Characters</LI>
</UL>
</td></tr>


<tr><th valign="middle" align="left" colspan="2" class="spanrow">
Search Form Fields
</th></tr>

<tr><td valign="top" align="left" colspan="2" class="help">
These are the fields across the top of each page. Each searches for a specific thing.
If you point at one of them with the mouse, it'll pop up a little box filled with
what that field searches for, in every language I could find. I'm sure a lot of them
aren't all that accurate, a lot was probably lost in translation (I mean, <I>you</I>
try finding the Vietnamese word for "hexadecimal"), but it should give everyone at
least a little idea of what the field's for. I did it 'cause I thought it'd help,
okay?? Stop hitting me!<BR><BR>
Anyway... here's what each field's for. Bon app&#233;tit.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Character Block
</th><td valign="top" class="help">
This dropdown field at the top of the page will take you directly to one of the
Unicode code blocks.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Shift-JIS (hex)
</th><td valign="top" class="help">
If you want to see all details of a character whose Shift-JIS code you know, put
the code here in hexadecimal and submit it. At most, one character can be searched
for with this field.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Unicode (hex)
</th><td valign="top" class="help">
If you want to see all details of a character whose Unicode Codepoint you know, put
the code here in hexadecimal and submit it. At most, one character can be searched
for with this field.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Unicode (dec)
</th><td valign="top" class="help">
This is for the decimal (base-ten) number that's equivalent to a character's <I>hex</I>
Codepoint. At most, one character can be searched for with this field.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
UTF8 Hex Code
</th><td valign="top" class="help">
You can enter a hexadecimal number in this field, of up to 255 characters, to display every
character the string of hex you entered represents. It must be valid UTF-8-encoded hex,
in big-endian. For example, to retrieve our "combining form" example above, enter this into
the field (the three UTF-8 codes for the three characters in it, which in this case is a
trio of <I>trios</I> of octets... that is, three pairs of hex digits ["octets"] per character):
<blockquote>
E0B897 E0B8B5 E0B988
</blockquote>
The spaces are in there just for clarity. It'd work just as well with it all smashed together
like "E0B897E0B8B5E0B988". Four-octet UTF-8 codes are also supported; F0AFA294 for instance,
which is the Codepoint 0x2F894. (Putting "0x" before a number means it's in hexadecimal; this
field is even smart enough to remove those and other non-hexadecimal characters first.)
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
UTF8 String
</th><td valign="top" class="help">
This is the Field of Power. You can cut'n'paste up to 255 characters -- <I>ANY</I> characters -- into this field
and it'll tell you everything it knows about every one of them, in order... assuming your browser
understands the UTF-8 encoding scheme, which every browser these days <I>should</I> understand.
If this field doesn't work for you, it might be time to upgrade from Windows '95 to something a
tad more... modern. Like <a target="_blank" href="http://www.gentoo.org/">Gentoo Linux</a>.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Description
</th><td valign="top" class="help">
This is the full, official English name of a character. Every CJK (Chinese, Japanese, Korean) Kanji
character has the description "Kanji Character" or no description at all; those it's best to search for by
their Definition instead. Believe it or not, the character
"a" has the official name "Latin Small Letter A". &#12343; is "Ideographic Telegraph Line Feed Separator Symbol",
but I think "Dos Equis" would have been a better name, don't you? &#411; is called "Latin Small Letter Lambda
With Stroke" (and I bet it looks like a little square to you if you're using Internet Explorer&trade;). And so on.
(If I'd have had to come up with names for all these things, I'd have been "With Stroke" too, maybe even "&#9897;"
(also known as "Horizontal Male With Stroke"), but my font doesn't support that one so who knows.)
<BR><BR>
Any combination of words can be searched for in here. If you want all the Hiragana characters with an "i" in
their Description, put "hiragana letter i" in this box (there's only fifteen of them). Partial words are matched
too, and it's not case-sensitive; "hIrA LetT I" works just as well.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Eng. Definition
</th><td valign="top" class="help">
Searching in this field yields all the characters which have a definition containing the words (or, again,
partial words) you enter. A definition in English. Sorry, world; that's what the Unicode people wrote all the
definitions in.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Pronunciation
</th><td valign="top" class="help">
Remember the big list of languages Unisearcher collects pronunciations for? You can search for them here.
If you want the character the Koreans pronounce "Phwung", put that into this field and then pick, from among
the eleven results it returns, whichever one of them you were looking for. <I>Note!</I> This field does <B>not</B>
do partial words! Entering "Phwun" will only return one character, and it won't return "Phwung" ones.
Oh; to search for, say, a Cantonese character pronounced as "gei3" (and I don't even really know what that means
but God bless the internet [update: it's "gei falling-sound", which is just as funny]), enter "gei-3" into this
field, <I>not</I> "gei3". I put dashes in all of them, for both Cantonese and Pinyin. And it's not case-sensitive
either. <I>Note:</I> this particular query also returns characters that are pronounced "gei3" in Pinyin. For all
I know a Cantonese "gei3" doesn't even sound like a Pinyin "gei3". But all the pronunciations are in the same
database field, so what can ya do.
</td></tr>


<tr><th valign="middle" align="left" colspan="2" class="spanrow">
Code Page Navigation
</th></tr>

<tr><td valign="top" align="left" colspan="2" class="help">
The three or four big yellow rows you see at the top of most pages is where you can quickly select a code block
to zip to if you know its first two or three hex digits. The character whose codepoint is 0x2F894 is in the
"upper" codepoint block because it has <I>five</I> hex digits in it. The codepoint 0x3D4C, having only four
digits, <I>actually</I> starts with "<B>0</B>", making it 0x03D4C. So try to think of them all as having
five digits, left-padded with zeroes, no matter how many digits are in them. It helps. And here's how to
handle each of the number's first three digits; we'll use "0x03D4C" as our example codepoint:<BR><BR>
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Top-Level
</th><td valign="top" class="help">
This will be "0", as in 0x<font class="hichar">0</font>3D4C. It's the first digit of the <B>five</B>-digit codepoint.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Next-Level
</th><td valign="top" class="help">
This will be "3", as in 0x0<font class="hichar">3</font>D4C. It's the second digit of five.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Last-Level
</th><td valign="top" class="help">
This will be "D", as in 0x03<font class="hichar">D</font>4C. It's the third digit of five.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Block Nav
</th><td valign="top" class="help">
This provides an easy way to jump forward or backward one single 256-character page, to show
another code block (or just the previous/next page in the current codeblock if it's a big one).
</td></tr>

<tr><td valign="top" align="left" colspan="2" class="help">
So if you want to get to the page where 0x03D4C lives, you'd click the "0" in top-level, the "3" in
next-level, and the "D" in last-level. Number 4C (out of FF) on the page you'll land on is in the 5th row,
column 12 (or as we programmers like to call it, "The 'C' Column" [since 12 is "C" in hex, go ahead and laugh,
but you'll notice that EVERY character's codepoint in that column ends with "C" -- <I>magic???</I> ]).
The final two digits, 4 and C, aren't needed for this navigation section; every possible combination of
the last two digits is represented on the page, from 00 to FF (0 to 255 in decimal).<BR><BR>
And, if you hadn't noticed, the three levels for the current page/subpage will have magenta backgrounds.
I hope everyone likes the color scheme; if not, play with your own "style.css" file once you download it.
If you ever need to go to the page currently highlighted in all three levels, say if you're viewing a single
glyph but the nav is still set thanks to 'page' and 'subpage,' just click on whichever "Last-level" digit is
already highlighted. Handy.
</td></tr>


<tr><th valign="middle" align="left" colspan="2" class="spanrow">
Advanced Topics
</th></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Direct URL Links
</th><td valign="top" class="help">
<I>If,</I> for some probably-metaphysical reason, you want to bookmark a certain page but don't see it
in the URL bar of your browser because the page resulted from a form being posted or something, you can
manually recreate a URL to that page by setting the right "get variables" in the URL. Continuing our
overworked 3D4C example, the following URL will get you to the full 256-character chart page containing
it. "page" is the top- and next-levels combined (top-level defaults to 0 if "page" is just a single digit),
and "subpage" is the single last-level digit.

<blockquote>
index.php?page=3&subpage=D&hilite=3D4C
<a href="index.php?page=3&subpage=D&hilite=3D4C" target="_blank">(Link)</a>
</blockquote>

"page" and "subpage" have to both be set for it to show you a full chart page.
"hilite" just makes one of them bright-yellow, to highlight it and catch your <font class="hichar">eye</font>.

<blockquote>
index.php?page=03&subpage=D&glyph=03D4C
<a href="index.php?page=03&subpage=D&glyph=03D4C" target="_blank">(Link)</a>
</blockquote>

That URL takes you to the details page for a single character (what I euphemistically decided to call a "glyph"
for reasons not <I>entirely</I> geeky in nature. Just remember, a "glyph" <I>is</I> a hexadecimal codepoint
<I>and</I> a single character; it's all synonymous). "page" and "subpage" are actually optional in it; they
just tell it how to set the "current" three levels in the navigation. "glyph" if present in a URL triggers
showing just the details of a single character.<BR><BR>

And for your convenience, there's yet another tool available. Any time you use the search form to find a set
of glyphs, a "URL to the results below" link will appear to the left of the "Glyph Entry Key." That link can
be bookmarked to quickly retrieve the results of any search you ever perform. You're welcome.<BR><BR>

Notice how the top two "levels" are combined into the "page" variable. If page is "5", it's effectively the same
as telling it "page=05". You can go all the way up to "page=FF&subpage=F" before you'll make it cry. Actually it won't
cry, it'll just reset the page to "0" for you, quietly, so it doesn't embarass you in front of your geek friends.
</td></tr>


<tr><th nowrap valign="top" align="left" class="help_hdr">
Serving Suggestions
</th><td valign="top" class="help">
So you have this tool now; what do you do with it? What <I>can</I> you do with it? Well, "all sorts of things."
<UL>

<LI><B>Make Web Pages</B> - like this one. My style is to just use the HTML entity for a character, like, instead of 
actually embedding the binary string for that combined Thai character up there, I used the three codepoints in decimal 
like this: <tt>&amp;#3607;&amp;#3637;&amp;#3656;</tt>. You can see that in the view-source for this page. But I 
<I>also</I> could have just embedded that binary like this...

<big>ที่</big>

...and it works just as well, and takes up only nine bytes instead of twenty-one like the entities version, because of 
something I put into the HTML header for every page:

<PRE>
&lt;meta http-equiv="content-type" content="text/html; charset=UTF-8" /&gt;
</PRE>

Forcing browsers to use UTF-8 for a page is the best way to make sure everyone can view anything you put on it... as 
long as it's UTF-8. The HTML entities, like &amp;#3607;, are converted into the right UTF-8 code by the browser and 
displayed. I think. It's a bit fanciful and magical, something to do with wood nymphs or something. Anyway, UniSearcher 
can help you find the various codes you need to display those characters as long as you know how to search for them. 
Usually it's just as easy as pasting or typing a string into the "UTF8 String" field, hitting enter, copying it all to 
the clipboard, finding the format you wanted to display those characters with, and cutting'n'pasting it into whatever 
you're writing. Your "operating system" should know how to paste things from its clipboard into web page forms, 
converting it all itself to match that "UTF8" charset declaration on the page, so that <I>should</I> work for anyone... 
I hope. And if you're the kind of programmer who hates trying to find and use editors that understand multibyte strings, 
like I am, using the HTML entities is the way to go. That's why the lang.phps file uses entities instead of actual MB 
strings even though it takes up <I>so</I> much more space. I'm not lazy; I'm just addicted to pico. I imagine "vi" users 
will sympathize with me; I have no idea if vi supports MB or not. But the allchars*.php pages <I>do</I> use actual UTF8 
characters instead of HTML entities; that's why they're only 450K instead of about a meg. UniSearcher makes it easy to 
use whichever method you want, is the point. </LI><BR>

<LI><B>Define Text in Programs</B> - The UniSearcher makes it a breeze for programmers using just about any programming 
or scripting language to create MB strings inside programs. It'll give you "\x20" for a space, for instance, and that 
can, I believe, be slapped in as-is to create an MB string. It can in PHP and perl, at least. The URL form is also 
provided; "%20" for a space, for instance, or "%E0%B8%97%E0%B8%B5%E0%B9%88" for our combined Thai. Big- and 
little-endian versions of the UTF8 hex code are also shown. All you have to do is put something on its clipboard and all 
secrets are revealed. If I missed any desired output format, just let me know. </LI><BR>

<LI><B>Amaze Your Friends</B> - if they're geeks. It's not just a tool for geeks, though. I can just about translate 
Chinese web pages now by just cutting and pasting from the page into Unisearcher and then reading the definitions for 
all the characters one after the other. It's made going through my daily spam dosage a whole new experience. Spam in 
foreign languages is <I>fun</I> now. Educational. Imagine the looks on your friends' faces when you tell them it's an 
email for tiny paper lanterns hand-made by children in Chengdu! Imagine their awe! Now stop daydreaming and get to work. 
</LI><BR>

<LI><B>Save the World</B> - Hey, it could happen. Language and religion are the only two things standing in the way of 
uniting the world. Well... and money and power, but I won't go there. </LI>

</UL>

</td></tr>


<tr><th valign="middle" align="left" colspan="2" class="spanrow">
Other Available Things
</th></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
All-Characters<BR>Display Pages
</th><td valign="top" class="help">
<a href="allchars1.php">This page</a> will display for you <I>every</I> single defined Unicode codepoint. It can easily 
bring your browser to its knees, so be patient while it's loading. I recommend disabling "smooth scrolling" before 
loading it. There are only <?=$ccount?> characters defined right now, though, so it's not like it'll be putting over a 
million characters on your screen. <a href="allchars2.php">This page</a> is the same thing, but organized by the code
blocks rather than codepoints.
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Source Code
</th><td valign="top" class="help">

<B>Individual scripts:</B>
<UL>
<LI><a href="index.phps" target="_blank">Index/Search Form Page</a></LI>
<LI><a href="clipboard.phps" target="_blank">The Helper Clipboard</a></LI>
<LI><a href="functions.phps" target="_blank">Function Library</a></LI>
<LI><a href="parser.phps" target="_blank">Unicode Data Importer Script</a></LI>
<LI><a href="unicode.sql" target="_blank">SQL Data Structure</a></LI>
<LI><a href="style.css" target="_blank">CSS Stylesheet</a></LI>
<LI><a href="meta.phps" target="_blank">Meta Tag Generator</a></LI>
<LI><a href="inc.js" target="_blank">Misc. Javascript Functions</a></LI>
<LI><a href="hints.js" target="_blank">Popup Hint Functions</a></LI>
<LI><a href="navhints.phps" target="_blank">Popups for the Search Fields</a></LI>
<LI><a href="lang.phps" target="_blank">Multi-language Labels for the Search Fields</a></LI>
</td></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Artist Contact
</th><td valign="top" class="help">
You can always reach me at
<a href="mailto:phee@isthisthingon.org?subject=Unisearcher">phee@isthisthingon.org</a>
if you have any problems with the Unisearcher or just want to opinionize about it.
</td></tr>


<tr><th valign="middle" align="left" colspan="2" class="spanrow">
Unavailable Things
</th></tr>

<tr><th nowrap valign="top" align="left" class="help_hdr">
Nothing
</th><td valign="top" class="help">
That I know of. <pre>:')</pre> Well, except maybe support for all possible codepages and character sets.
I only know of one thing that can do that; PHP's mb_string functions. I avoided using those because not
everyone has them available in their PHP installation. Unisearcher has all the support it needs built into
it; no weird modules or extensions are necessary. It should run on any out-of-the-box PHP install.
</td></tr>


</table>

</body></html>
